<?

//Hide <s_article_rep>
function JMTC_SimplePostHide($target) { 
	global $configVal, $suri, $view;
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);

	if((!$suri['value'] && $suri['directive']!="/rss") 
			&& (($data['s1'])?$suri['directive']=="/":"")
			|| (($data['s2'])?$suri['directive']=="/category":"")
			|| (($data['s3'])?$suri['directive']=="/archive":"") 
			|| (($data['s4'])?$suri['directive']=="/search":"") 
			|| (($data['s5'])?$suri['directive']=="/tag":"") 
			){
				misc::dress('article_rep', "", $view);
	}			

	return $target;
}

//Show Simple Post
function JMTC_SimplePostShow($target) { 
	global $configVal, $service, $blog, $blogURL, $pluginURL, $pluginPath, $database, $skinSetting, $defaultURL, $suri, $entry, $blogid, $search, $category, $tag, $period;

	require_once('JMTC_thumb_engine.php');
	requireComponent('Textcube.Function.misc');

	$data = misc::fetchConfigVal($configVal);

	$data['maxLength']	= ($data['maxLength'])?$data['maxLength']:300;
	$data['imgWidth']	= ($data['imgWidth'])?$data['imgWidth']:120;
	$data['imgHeight']	= ($data['imgHeight'])?$data['imgHeight']:86;
	$data['new']	= ($data['new'])?$data['new']:1;
	$data['urlimg']	= ($data['urlimg'])?$data['urlimg']:1;
	
	if((!$suri['value'] && $suri['directive']!="/rss") 
			&& (($data['s1'])?$suri['directive']=="/":"")
			|| (($data['s2'])?$suri['directive']=="/category":"")
			|| (($data['s3'])?$suri['directive']=="/archive":"") 
			|| (($data['s4'])?$suri['directive']=="/search":"") 
			|| (($data['s5'])?$suri['directive']=="/tag":"") 
			){

			if($suri['directive']=="/category") {
				list($entries,$paging)=JMTC_getEntriesWithPagingByCategory($blogid,$category,$suri['page'],$blog['entriesOnList'],($skinSetting['showListOnCategory']==3?$blog['entriesOnPage']:$blog['entriesOnList']));
			} else if($suri['directive']=="/archive") {
				list($entries,$paging)=JMTC_getEntriesWithPagingByPeriod($blogid,$period,$suri['page'],$blog['entriesOnPage']);
			} else if($suri['directive']=="/search") {
				list($entries,$paging)=JMTC_getEntriesWithPagingBySearch($blogid,$search,$suri['page'],$blog['entriesOnList'],$blog['entriesOnList']);
			} else if($suri['directive']=="/tag") {
				list($entries,$paging)=JMTC_getEntriesWithPagingByTag($blogid,$tag,$suri['page'],$blog['entriesOnList'],($skinSetting['showListOnTag']==3?$blog['entriesOnPage']:$blog['entriesOnList']));	
			} else {
		  	list($entries,$paging)=JMTC_getEntriesWithPaging($blogid,$suri['page'],$blog['entriesOnPage']);
			}	

			//Check Time
			$today = time();
			$chkTime = $today - ( 86400 * $data['new']);
			
			foreach($entries as $entry){

				//Subject
				$title_name = htmlspecialchars(fireEvent('ViewPostTitle',$entry['title'],$entry['id']));
				$title_link = "$blogURL/".($blog['useSlogan']?"entry/".encodeURL($entry['slogan']):$entry['id']);
				$title = "<a href=\"".$title_link."\">".$title_name."</a>";
				
				//Category
				$cate_name = htmlspecialchars(empty($entry['category'])?_text('분류없음'):$entry['categoryLabel'],$entry['id']);
				$cate_link = empty($entry['category'])?"$blogURL/category/":"$blogURL/category/".encodeURL($entry['categoryLabel']);
				$cate = "<a href=\"".$cate_link."\">".$cate_name."</a>";

				//Content
				$content = JMTC_stripHTMLandTag($entry['content']);
				$content = UTF8::lessenAsEm($content, $data['maxLength']);
	
				//Date
				$date = fireEvent('ViewPostDate',Timestamp::format3($entry['published']));

				//Comment Count, Trackback Count
				$cmt = ($entry['comments'])?$entry['comments']:0;
				$tb = ($entry['trackbacks'])?$entry['trackbacks']:0;

				//New Icon
				if(($entry['published'] > $chkTime) && ($entry['published'] < $today)) {
					$new = "<img src=\"".$pluginURL."/new.gif\" align=\"absmiddle\" border=\"0\" />";
				} else {
					$new = "";					
				}		

				//Attacked Image
				$img_load = ($data['img_load']==2)?" rand() ":" attached ASC";
				$f_name = DBQuery::queryCell("SELECT name FROM {$database['prefix']}Attachments WHERE  (name LIKE '%.jpg' OR name LIKE '%.gif' OR name LIKE '%.png') AND blogid = {$blogid} AND parent = {$entry['id']} ORDER BY {$img_load} ");
				if($f_name || $data['urlimg']==1){
					$filename = ($matches=explode(".", $f_name))?$matches[0]:NULL;
					$targetfile = ROOT."/thumbnail/JMTC_SimplePost/{$blogid}/{$filename}".".thumb";
					$sourcefile = ROOT."/attach/$blogid/{$f_name}";
					$img_tag = JMTC_getThumbTag($entry['id'], $filename, $entry['content'], &$sourcefile, $data['imgWidth'], $data['imgHeight'], $targetfile, $mode="thumb", $data['resize'], $data['quality'], $data['urlimg']);
				}

				if(!$img_tag[2] || (basename($img_tag[2]) == "no_screenshot.jpg")){
						$filename = "no_screenshot";
						$targetfile = ROOT."/thumbnail/JMTC_SimplePost/{$blogid}/{$filename}".".thumb";
						$sourcefile = $pluginPath."/no_screenshot.jpg";
						$img_tag = JMTC_getThumbTag($entry['id'], $filename, $no_content, &$sourcefile, $data['imgWidth'], $data['imgHeight'], $targetfile, $mode="thumb", $data['resize'], $data['quality'], $data['urlimg']);
				}
				
				$img_url = $service['path'].str_replace(ROOT, "", $img_tag[2]);
				$link_image = "<a href=\"".$title_link."\"><img src=\"".$img_url."\" width=\"".$data['imgWidth']."\" height=\"".$data['imgHeight']."\" border=\"0\" /></a>";
				$image = "<img src=\"".$img_url."\" width=\"".$data['imgWidth']."\" height=\"".$data['imgHeight']."\" border=\"0\" />";
				
				$list_tmp = str_replace("[##_Image_##]",$image,$data['list']);
				$list_tmp = str_replace("[##_LinkImage_##]",$link_image,$list_tmp);
				$list_tmp = str_replace("[##_Subject_##]",$title,$list_tmp);
				$list_tmp = str_replace("[##_NewIcon_##]",$new,$list_tmp);
				$list_tmp = str_replace("[##_Category_##]",$cate,$list_tmp);
				$list_tmp = str_replace("[##_Desc_##]",$content,$list_tmp);
				$list_tmp = str_replace("[##_Date_##]",$date,$list_tmp);
				$list_tmp = str_replace("[##_Cmt_##]",$cmt,$list_tmp);
				$list_tmp = str_replace("[##_Tb_##]",$tb,$list_tmp);
				$list .= $list_tmp;																
			}

		if($data['s1'] && ($suri['directive']=="/")) {
			$home_title = $data['title'];
			$home_title = str_replace("./",$pluginURL."/",$home_title);
		} else {
			$home_title = "";
		}

		$target .= str_replace("[##_Home_Title_##]",$home_title,$data['top']);
		$target .= $list;
		$target .= $data['bottom'];		

	}
	
	return $target;

}

//CFG Chieck
function JMTC_SimplePostDataSet($data){
	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($data);
	$checkSuriDirective = array();
	for($i=0; $i <= 5; $i++){
		if($cfg['s'.$i]) 
		array_push($checkSuriDirective, $cfg['s'.$i]);
	}
		 
	if(count($checkSuriDirective)==0) return "::선택 오류::\n\n적용 범위는 적어도 하나이상 선택하셔야 합니다.";
	return true;
}

//General
function JMTC_getEntriesWithPaging($blogid, $page, $count) {
	global $database;
	$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	$sql = "SELECT e.*, c.label categoryLabel 
		FROM {$database['prefix']}Entries e 
		LEFT JOIN {$database['prefix']}Categories c ON e.blogid = c.blogid AND e.category = c.id 
		WHERE e.blogid = $blogid AND e.draft = 0 $visibility AND e.category >= 0 
		ORDER BY e.published DESC";
	return fetchWithPaging($sql, $page, $count);
}

//Search
function JMTC_getEntriesWithPagingBySearch($blogid, $search, $page, $count, $countItem) {
	global $database, $folderURL, $suri;
	$search = escapeMysqlSearchString($search);
	$cond = strlen($search) == 0 ? 'AND 0' : "AND (e.title LIKE '%$search%' OR e.content LIKE '%$search%')";
	$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 1 AND (c.visibility > 1 OR e.category = 0)';
	$sql = "SELECT e.*, c.label categoryLabel 
		FROM {$database['prefix']}Entries e 
		LEFT JOIN {$database['prefix']}Categories c ON e.blogid = c.blogid AND e.category = c.id 
		WHERE e.blogid = $blogid AND e.draft = 0 $visibility AND e.category >= 0 $cond 
		ORDER BY e.published DESC";
	return fetchWithPaging($sql, $page, $count, "$folderURL/{$suri['value']}","?page=", $countItem);
}

//Category
function JMTC_getEntriesWithPagingByCategory($blogid, $category, $page, $count, $countItem) {
	global $database, $folderURL, $suri;
	if ($category === null)
		return fetchWithPaging(null, $page, $count, "$folderURL/{$suri['value']}");
	$visibility = doesHaveOwnership() ? '' : 'AND visibility > 1';
	if ($category > 0) {
		$categories = DBQuery::queryColumn("SELECT id FROM {$database['prefix']}Categories WHERE blogid = $blogid AND parent = $category $visibility");
		array_push($categories, $category);
		$cond = 'AND e.category IN (' . implode(', ', $categories) . ')';
		$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 0';
	} else {
		$cond = 'AND e.category >= 0';
		$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	}
	$sql = "SELECT e.*, c.label AS categoryLabel 
		FROM {$database['prefix']}Entries AS e 
		LEFT JOIN {$database['prefix']}Categories c ON e.category = c.id AND e.blogid = c.blogid 
		WHERE e.blogid = $blogid AND e.draft = 0 $visibility $cond 
		ORDER BY e.published DESC";
	return fetchWithPaging($sql, $page, $count, "$folderURL/{$suri['value']}","?page=",$countItem);
}

//Tags
function JMTC_getEntriesWithPagingByTag($blogid, $tag, $page, $count, $countItem = null) {
	global $database, $folderURL, $suri;
	if ($tag === null)
		return fetchWithPaging(null, $page, $count, "$folderURL/{$suri['value']}");
	$tag = mysql_tt_escape_string($tag);
	$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	$sql = "SELECT e.*, c.label categoryLabel 
		FROM {$database['prefix']}Entries e
		LEFT JOIN {$database['prefix']}Categories c ON e.blogid = c.blogid AND e.category = c.id 
		LEFT JOIN {$database['prefix']}TagRelations t ON e.id = t.entry AND e.blogid = t.blogid 
		WHERE e.blogid = $blogid AND e.draft = 0 $visibility AND e.category >= 0 AND t.tag = '$tag' 
		ORDER BY e.published DESC";
	return fetchWithPaging($sql, $page, $count, "$folderURL/{$suri['value']}","?page=", $countItem);
}

//Archive
function JMTC_getEntriesWithPagingByPeriod($blogid, $period, $page, $count) {
	global $database, $folderURL, $suri;
	$cond = "AND published >= " . getTimeFromPeriod($period) . " AND published < " . getTimeFromPeriod(addPeriod($period));
	$visibility = doesHaveOwnership() ? '' : 'AND e.visibility > 0 AND (c.visibility > 1 OR e.category = 0)';
	$sql = "SELECT e.*, c.label categoryLabel 
		FROM {$database['prefix']}Entries e 
		LEFT JOIN {$database['prefix']}Categories c ON e.blogid = c.blogid AND e.category = c.id 
		WHERE e.blogid = $blogid AND e.draft = 0 $visibility AND e.category >= 0 $cond 
		ORDER BY e.published DESC";
	return fetchWithPaging($sql, $page, $count, "$folderURL/{$suri['value']}");
}

// Tag Remove
function JMTC_stripHTMLandTag($text){
	$text=preg_replace('/<(script|style)[^>]*>.*?<\/\1>/si','',$text);	
	$text=preg_replace('/<[\w\/!]+[^>]*>/','',$text);	
	$text=preg_replace('/&nbsp;?/',' ',$text);
	$text=trim(preg_replace('/\s+/',' ',$text));
	$text=preg_replace('/\[#M_[^|]*\|[^|]*\|/Us','',str_replace('_M#]','',preg_replace('/\[##_.+_##\]/Us','',$text)));
	$text=preg_replace('@(<s_|</s_)[0-1a-zA-Z_]+>@','',$text);
	$text=str_replace(array('&#39;','&apos;','&quot;'),array('\'','\'','"'),$text);
	return $text;
}

?>
